//bluetooth.c
#include<system.h>
#include "serial.h"

extern char buffer[8];

void BT_Reset()
{
	trisc.2 = 0;
	portc.2 = 0;
}

void BT_Start()
{
	trisc.2 = 0;
	portc.2 = 1;
}

void BT_CloseConnection()
{
	trisb.3 = 0;
	portb.3 = 1;
}

void BT_OpenConnection()
{
	trisb.3 = 0;
	portb.3 = 0;
}

void BT_EnterHCM()
{
	char command = 0x01; 
	char lenght = 0x04; 
	char code[4]={0xFF,0x00,0x55,0xAA};
	unsigned char i;

	
	sendByte(command);
	sendByte(lenght);

	for(i=0; i<lenght; i++)
		sendByte(code[i]);

	delay_ms(5);
	readString(buffer, 3); //response stored in buffer
}

void BT_SetSerialPortConfig(unsigned char baudrate, unsigned char flowcontrol,
unsigned char parity, unsigned char databits, unsigned char stopbits)
{
	
	char command = 0x15; 
	char lenght = 0x05; 
	unsigned char code[5];
	unsigned char i;

	code[0]=baudrate;
	code[1]=flowcontrol;
	code[2]=parity;
	code[3]=databits;
	code[4]=stopbits;

	sendByte(command);
	sendByte(lenght);

	for(i=0; i<lenght; i++)
		sendByte(code[i]);

	delay_ms(5);
	readString(buffer, 3); //response stored in buffer
}

void BT_SetLocalBluetoothName(unsigned char *name)
{
	char command = 0x1D; 
	char lenght;
	unsigned char i;
 
	for(lenght=0x00; name[lenght]!='\0' && lenght<19; lenght++);
		name[lenght++]='\0';
	
	sendByte(command);
	sendByte(lenght);

	for(i=0; i<lenght; i++)
		sendByte(name[i]);

	delay_ms(5);
	readString(buffer, 3); //response stored in buffer
}

void BT_RunReboot()
{
	char command = 0x50; 
	char lenght = 0x00; 
	char code = 0x00;
	
	sendByte(command);
	sendByte(lenght);
	sendByte(code);

	delay_ms(5);
	readString(buffer, 3); //response stored in buffer
}

//Add more Bluetooth functions here
//Follow the "Wireless_UART_protocol_v4"