//irq.c
#include<system.h>

extern unsigned long ms_timer;
extern char rxBuffer[16];
extern char rxCount;
extern unsigned char button_pressed;

void interrupt()
{
	char i = 0;
	if((pir1 & 0x01) == 0x01) //Timer1 Overflow interrupt
	{
		tmr1h = 0xF8;	//65536-2000 = 63536 = 0xF830 -> 1ms
		tmr1l = 0x30;
		ms_timer++;

		pir1 = pir1 & 0xFE;	// clear Timer1 interrupt flag
	}

	//If external interrupt (INT0)
	/*if((intcon  & 0x02) == 0x02) // If INT0 
	{
		intcon &= 0xFD;
	}*/

	//If receive interrupt (rs232)
	if(pir1.RCIF == 1)
	{
		for(i = 15; i>0; i--)
			rxBuffer[i] = rxBuffer[i-1];
		rxCount++;

		rxBuffer[0] = rcreg;
		pir1.RCIF = 0;
	}


}

void initIRQ()
{

	//Timer Interuppt
	t1con = 0x85; // setup interuppts 16-bit operation; T1_DIV_BY_1; no syncronise ; enables timer1
	pie1 = pie1 | 0x01; //enables timer1 overflow interrupt
  	intcon = 0xC0; //global interrupt 

	// 8 mhz clock, no prescaler, set timer 1 to overflow in 1ms 
	// x=1ms/(4/f)=(0.001/(1/(8000000/4)))	 Fosc/4
	// 65536-2000 = 63536 = 0xF830 -> 1ms

	tmr1h = 0xF8;
	tmr1l = 0x30;

	/*
	//External interuppt
	intcon |= 0x10;	//enable INT0
	intcon2 |= 0x40; //rising edge INT0
	*/	
	
}
