//serial.c
#include<system.h>
#include"serial.h"

extern char rxBuffer[16];
extern char rxCount;

void initSerial(int BaudRate)
{
	//1. Set Baudrate
	spbrg = BaudRate;
	spbrgh = (BaudRate >> 8);
	txsta.BRGH = 1;
	baudctl.BRG16 = 1;

	//2. Enable asynchronous serial port
	txsta.SYNC = 0;
	rcsta.SPEN = 1;

	//3. Interrupt receiving 
	pie1.RCIE = 1; 

	//5. Enable reception
	rcsta.CREN = 1;

	//Enable transmision
	txsta.TXEN = 1;
}

char sendByte(char byte)
{
	int i;

	for(i = 0; i<20000 && txsta.TRMT == 0; i++); //wait for register to be empty
	
	if(i == 20000)
		return Fail;
	
	txreg = byte;
	return Pass;
}

char sendString(char *string)
{
	while(*string !=0)
		if (sendByte(*(string++)) == Fail)
			return Fail;

	return Pass;
}

char readByte()
{
		if(rxCount > 0)
			return rxBuffer[--rxCount];
		else
			return '\0';
}

char readString(char *buffer, char length)
{
	char i = 0;
	char byte;

	do
	{
		byte = readByte();
		if(byte != '\n')
			buffer[i++] = byte;
	}while((byte != '\n') && (i < length));

	buffer[i] = 0;

	return i;
}


void sendValueSerial(unsigned char value)
{
	unsigned char low, middle, high, temp, temp2, temp3;

	high = (unsigned char) (value/100);
	sendByte(high + 48);
	
	//	middle = (char) ((value-(high*100))/10);
	temp = high*100;
	temp2 = (value - temp);
	middle = (unsigned char) (temp2/10);
	sendByte(middle + 48);

	//low = (char) (value-(high*100)-(middle*10));
	temp = middle * 10;
	temp3 = temp2 - temp;
	low = (unsigned char) temp3;
	sendByte(low + 48);

}
